/**
 *Board and movement of pieces
 *@author arghavan soleymanpour
 *@version 2.0
 */
package Pieces;

import Main.Board;

import java.util.ArrayList;

public class Pawn extends Piece {


    public Pawn(int x, int y, boolean isWhite, Board board) {
        super(x, y, isWhite, board);
    }


    @Override
    public boolean isValidMove(int dx, int dy) {
        ArrayList<int[]> moves = moves();
        for (int m[] : moves){
            if(m[0]==dx && m[1] == dy){
                return true;
//                break;
            }
        }
        return false;
    }

    @Override
    public ArrayList<int[]> moves() {
        ArrayList<int[]> moves = new ArrayList<>();
        int x = getX();
        int y = getY();
        if(isWhite())
        {
            if(y==0)
                return moves;
            if(getBoard().isEmpty(x,y-1))
            {
                moves.add(new int[]{x,y-1});
                if(y==6)
                {
                    if(getBoard().isEmpty(x,4))
                        moves.add(new int[]{x,4});
                }
            }
            if((x>0)&& ((getBoard().getColor(x-1,y-1)==2 && isWhite()) || (getBoard().getColor(x-1,y-1)==1 && isBlack())))
                moves.add(new int[]{x-1,y-1});
            if((x<7)&&((getBoard().getColor(x+1,y-1)==2 && isWhite()) || (getBoard().getColor(x+1,y-1)==1 && isBlack())))
                moves.add(new int[]{x+1,y-1});
        }
        else
        {
            if(y==8)
                return moves;
            if(getBoard().isEmpty(x,y+1))
            {
                moves.add(new int[]{x,y+1});
                if(y==1)
                {
                    if(getBoard().isEmpty(x,3))
                        moves.add(new int[]{x,3});
                }
            }
            if((x>0)&& ((getBoard().getColor(x-1,y+1)==2 && isWhite()) ||(getBoard().getColor(x-1,y+1)==1 && isBlack())))
                moves.add(new int[]{x-1,y+1});
            if((x<7)&&((getBoard().getColor(x+1,y+1)==2 && isWhite()) ||(getBoard().getColor(x+1,y+1)==1 && isBlack())))
                moves.add(new int[]{x+1,y+1});
        }
        return moves;
    }

    @Override
    public String toString() {
        return "P";
    }
}
